//=================================================================
//
//  Simple RF powermeter
//
//  (c) Dietmar Krause, DL2SBA
//
//  License see https://creativecommons.org/licenses/by/4.0/
//
#include <avr/pgmspace.h>

#include <Nextion.h>
#include <PeakHold.h>

#include "data.h"

Nextion nex(NEXTION_PORT, true);


//=================================================================
//
//  various stuff
char dtostrfBuffer[20];
char strBuffer[20];



//=================================================================
//
//    Data buffer
//
volatile uint16_t dataBuffer[DATA_BUFFER_SIZE_MAX];
volatile uint16_t dataBufferIndex;
volatile uint16_t currentBufferSize;

//=================================================================
//
//    Data maintained by ISR
//
volatile uint16_t isrActValue;
volatile uint16_t isrAvgValue;
volatile MaximumHold minHold = MaximumHold(T_PEAKHOLD_INIT, T_PEAKDECAY_INIT, 20);
volatile MinimumHold maxHold = MinimumHold(T_PEAKHOLD_INIT, T_PEAKDECAY_INIT, 20);


//=================================================================
//
//    peakhold data
//
volatile uint16_t   peakHoldCurrent;
volatile uint16_t   peakDecayCurrent;

//=================================================================
//
//    meter main mode
//
uint8_t mode     = MODE_RUN;
int8_t  powerOffset_dB;
int8_t  powerOffset_Index;
int8_t  powerSteps[9] = {0, -3, -6, -10, -20, -30, -40, -50, -60};

uint8_t  calFreqIdx     = CALFREQ_INIT;
uint16_t calFreqSteps[CALFREQ_NUM] = {50, 150, 450, 1200, 2000, 3000};

//=================================================================
//
//    meter fast sampling mode
//
uint8_t  fastMode = false;

//=================================================================
//
//
uint8_t  backlight;

//=================================================================
//
//  calibration data
//
//  for 50MHz  correct factors
//  rest       dummy
//
//  k0              k1               k2              k3
const PROGMEM float kFactors[] = {
    2.804742194E1,  -3.432439417E-2, 5.570579072E-6, -1.015882955E-9,   //    50 MHZ
    2.804742194E1,  -3.432439417E-2, 5.570579072E-6, -1.015882955E-9,   //   150 MHZ
    2.804742194E1,  -3.432439417E-2, 5.570579072E-6, -1.015882955E-9,   //   450 MHz
    2.804742194E1,  -3.432439417E-2, 5.570579072E-6, -1.015882955E-9,   //  1200 MHz
    2.804742194E1,  -3.432439417E-2, 5.570579072E-6, -1.015882955E-9,   //  2000 MHz
    2.804742194E1,  -3.432439417E-2, 5.570579072E-6, -1.015882955E-9,   //  3000 MHz
};


